<template>
  <div class="d-md-flex align-items-center justify-content-betwenn flex-wrap p-2 pb-3 contenedorPrincipal mb-3">
    <div class="col-5 ms-3 mt-3">
      <label id="solicitante" class="form-label d-block">Solicitante:</label>

      <auto-complete class="d-inline" v-model="data.solicitante" :elements="solicitantesStore.solicitantes" initKey=""
        placeholder="Apellido/s y Nombre/s" :minLength="3" :disabled="false" id="solicitante" />

      <button type="button" class="d-inline btn btn-principal px-3 ms-3" alt="Ver cupos del solicitante"
        title="Ver cupos del solicitante" @click="validarVerCupos()">
        Ver cupos
      </button>

      <Modal ref="cuposModal" :size="'lg'" :title="cuposTitulo">
        <CuposModal :parametros="cuposParametros"></CuposModal>
      </Modal>
    </div>
    <div class="col-3 ms-3 mt-3">
      <label id="becario" class="form-label">Becario:</label>
      <auto-complete v-model="data.becario" :elements="becariosStore.becarios" initKey=""
        placeholder="Apellido/s y Nombre/s" :minLength="2" :disabled="false" id="becario" />
    </div>
    <div class="col-3 ms-3 mt-3">
      <label id="apoderado" class="form-label">Apoderado:</label>
      <auto-complete v-model="data.apoderado" :elements="becariosStore.becarios" initKey=""
        placeholder="Apellido/s y Nombre/s" :minLength="2" :disabled="false" id="apoderado" />
    </div>

    <div class="col-3 ms-3 mt-3">
      <label id="bloque" class="form-label">Bloque Pol&iacute;tico:</label>
      <auto-complete v-model="data.bloque" :elements="bloquesStore.bloques" initKey="" placeholder="Dependencia"
        :minLength="2" :disabled="false" id="bloque" />
    </div>
    <div class="col-3 ms-3 mt-3">
      <label id="baproSucursal" class="form-label">Sucursal Bapro:</label>
      <auto-complete v-model="data.baproSucursal" :elements="baproSucursalesStore.getBaproSucursales()" initKey=""
        placeholder="Sucursal" :minLength="2" :disabled="false" id="baproSucursal" />
    </div>
    <div class="col-4 ms-3 mt-3">
      <label id="responsable" class="form-label">Responsable:</label>
      <auto-complete v-model="data.responsable" :elements="solicitantesStore.solicYProyectos" initKey=""
        placeholder="Responsable" :minLength="2" :disabled="false" id="responsable" />
    </div>
    <div class="col-2 ms-3 mt-3">
      <label for="estado" class="form-label">Estado:</label>
      <select v-model="data.estado" class="form-select form-select-sm px-4" id="estado">
        <option :value="null" v-text="'--Todos--'"></option>
        <option :value="{ id_estado: 1, c_estado: 'A', d_estado: 'Activo' }" v-text="'Activo'"></option>
        <option :value="{ id_estado: 2, c_estado: 'B', d_estado: 'Baja' }" v-text="'Baja'"></option>
      </select>
    </div>
    <div class="col-2 ms-3 mt-3">
      <label for="visado" class="form-label">Visado:</label>
      <select v-model="data.visado" class="form-select form-select-sm px-4" id="visado">
        <option v-for="visado in visados" :value="visado" v-text="visado.d_visado"></option>
      </select>
    </div>
    <div class="col-2 ms-3 mt-3">
      <label for="orden" class="form-label">Orden:</label>
      <select v-model="data.orden" class="form-select form-select-sm px-4" id="orden">
        <!-- <option :value="null" v-text="'--Seleccione--'"></option> -->
        <option :value="'S'" v-text="'Por Solicitante'"></option>
        <option :value="'E'" v-text="'Por Expediente'"></option>
      </select>
    </div>
    <div class="col-2 ms-3 mt-3">
      <label for="f_desde" class="form-label" style="margin-top: 2px !important">Fecha Desde:</label>
      <input required type="date" v-model="data.f_desde" class="form-control" id="f_desde" autocomplete="off" />
    </div>
    <div class="col-2 ms-3 mt-3">
      <label for="f_hasta" class="form-label" style="margin-top: 2px !important">Fecha Hasta:</label>
      <input required type="date" v-model="data.f_hasta" class="form-control" id="f_hasta" autocomplete="off" />
    </div>
    <div class="col-5 ms-3 mt-3">
      <label for="expediente" class="form-label">Expediente:</label>
      <input-expediente v-model="data.expediente.expte" class="ms-1" :urlServer="urlComun" :tipo="data.expediente.tipo"
        :disabled="false" :disabledOrigenInput="true" />
    </div>

    <div class="col mt-3 text-end">
      <button type="button" class="btn btn-principal px-3 mt-2" alt="Buscar Becas " title="Buscar Becas"
        @click="buscarBecas()">
        <i class="bi bi-search"></i>
      </button>
      <button class="btn btn-principal px-3 mt-2 mx-2" alt="BLimpiar" title="Limpiar" @click="limpiarFormulario()">
        <i class="fs-6 p-2 px-0 fa-solid fa-broom"></i>
      </button>
    </div>
  </div>

  <ListadoInformeBecas :parametros="data"></ListadoInformeBecas>
</template>
  
<script setup lang="ts">

// Librerias
import { DateTime } from "luxon";
import { onMounted, reactive, computed, ref } from "vue";
import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions, SweetAlertResult } from "sweetalert2";
import { loading, isEmpty, urlComun } from "@/shared.js";
import { AutoComplete, Modal, InputExpediente, Expediente, } from "@hcd-bsas/vue3-components";
// Componentes
import ListadoInformeBecas from "@/components/becas/informeBecas/ListadoInformeBecas.vue";
import CuposModal from "@/components/becas/actualizacion/cupos/Modal.vue";
// Entidades
import Solicitante from "@/entities/Solicitante";
import type Becario from "@/entities/becas/Becario";
import type Bloque from "@/entities/Bloque";
import type BaproSucursal from "@/entities/becas/BaproSucursal";
import type Liquidacion from "@/entities/Liquidaciones/Liquidacion";
import type Estado from "@/entities/becas/Estado";
import type Visado from "@/entities/Visado";
// Stores
import { usePeriodosStore } from "@/stores/periodos";
import { useSolicitantesStore } from "@/stores/solicitantes";
import { useBecariosStore } from "@/stores/becas/becarios";
import { useBloquesStore } from "@/stores/bloques";
import { useBaproSucursalesStore } from "@/stores/becas/baproSucursales";
import { useBecasStore } from "@/stores/becas/becas";

const periodosStore = usePeriodosStore();
const solicitantesStore = useSolicitantesStore();
const becariosStore = useBecariosStore();
const bloquesStore = useBloquesStore();
const baproSucursalesStore = useBaproSucursalesStore();
const becasStore = useBecasStore();

const visados: Array<Visado> = [
  { id_visado: 1, d_visado: 'Visados', c_visado: '' },
  { id_visado: 0, d_visado: 'No Visados', c_visado: '' },
  { id_visado: null, d_visado: 'Sin Visar', c_visado: '' },
  { id_visado: 99, d_visado: 'Todos', c_visado: '' },
];

const fechaMostrar = (fecha: string | null) => (fecha !== null) ? DateTime.fromISO(fecha).toFormat('dd/MM/yyyy') : "";
const valFDesde = computed(() => !isEmpty(data.f_desde));
const valFHasta = computed(() => !isEmpty(data.f_hasta));
const valSolicitante = computed(() => !isEmpty(data.solicitante));

const anioActivo = computed(() => String(periodosStore.periodos.activo?.anioActivo!));
const cuposTitulo = computed(() =>
  'Cupos del solicitante "' + data.solicitante?.ayn + '"' +
  ' desde el ' + fechaMostrar(String(data.f_desde)) +
  ' hasta el ' + fechaMostrar(String(data.f_hasta))
);
const cuposParametros = computed(() => ({
  f_cupo_des: data.f_desde,
  f_cupo_has: data.f_hasta,
  id_tabla_sol: data.solicitante?.id_tabla_sol,
  usar_perfil_consulta: 0
}));
const cuposModal = ref(Modal);

const data = reactive({
  solicitante: undefined as Solicitante | undefined,
  f_desde: null as String | null,
  f_hasta: null as String | null,
  becario: undefined as Becario | undefined,
  apoderado: undefined as Becario | undefined,
  bloque: undefined as Bloque | undefined,
  baproSucursal: undefined as BaproSucursal | undefined,
  responsable: undefined as Solicitante | undefined,
  liquidaciones: undefined as Liquidacion | undefined,
  estado: null as Estado | null,
  visado: visados[3] as Visado,
  orden: 'S' as String | null,
  //el componente de expediente
  expediente: {
    tipo: 'S',
    expte: { origen: "I-A", anio: anioActivo.value, alcance: 0, id: null } as Expediente
  }
});

onMounted(async () => {
  loading.show();
  await cargar();
  loading.hide();
});

function validarVerCupos() {
  const swal: SweetAlertOptions = {
    icon: "error",
    title: "Error",
    html: "",
  };
  if (!valFDesde.value) {
    swal.html = 'Por favor, complete el campo "Fecha Desde".';
  } else if (!valFHasta.value) {
    swal.html = 'Por favor, complete el campo "Fecha Hasta".';
  } else if (!valSolicitante.value) {
    swal.html = 'Por favor, complete el campo "Solicitante".';
  }
  if (!isEmpty(swal.html)) {
    Swal.fire(swal);
    return;
  }
  verCupos();
}

function verCupos() {
  cuposModal.value?.show();
}

function limpiarFormulario() {
  data.bloque = undefined;
  data.solicitante = undefined;
  data.f_desde = anioActivo.value + '-03-01';
  data.f_hasta = anioActivo.value + '-12-31';
  data.becario = undefined;
  data.apoderado = undefined;
  data.baproSucursal = undefined;
  data.responsable = undefined;
  becasStore.becas = [];

}

async function cargar() {
  await Promise.all([
    periodosStore.fetchPeriodos(),
    solicitantesStore.fetchSolicYProyectos(1),
    becariosStore.fetchBecarios(),
    bloquesStore.fetchBloques(),
    baproSucursalesStore.fetchBaproSucursales(),
    becasStore.becas = [],
  ]);
  data.f_desde = anioActivo.value + '-03-01';
  data.f_hasta = anioActivo.value + '-12-31';
  data.expediente.expte.anio = anioActivo.value;
}

async function buscarBecas() {

  loading.show();
  console.log(data.visado.id_visado);
  const paramsRequest: Object = {
    f_desde: data.f_desde,
    f_hasta: data.f_hasta,
    id_tabla_sol: data.solicitante?.id_tabla_sol,
    id_beca: null,
    id_becario: data.becario?.id_becario,
    id_apoderado: data.apoderado?.id_becario,
    id_dependen: data.bloque?.id_dependen,
    baprosuc: data.baproSucursal?.c_bapro,
    id_tabla_sol_responsable: data.responsable?.id_tabla_sol,
    estado: data.estado?.c_estado,
    usar_perfil_consulta: 0,
    id_expte: data.expediente.expte?.id,
    cond_visado: data.visado.id_visado,
    orden: data.orden,
  };
  await becasStore.informeBecasListar(paramsRequest);
  loading.hide();
}

</script>
  
  <!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
  